<stg><name>cache_module_Pipeline_VITIS_LOOP_11_1</name>


<trans_list>

<trans id="50" from="1" to="2">
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>
</trans>

<trans id="47" from="2" to="3">
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>
</trans>
</trans_list>



<state_list>

<state id="1" st_id="2">

<operation id="6" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="3" bw="3" op_0_bw="32">
<![CDATA[
newFuncRoot:0 %i = alloca i32 1

]]></Node>
<StgValue><ssdm name="i"/></StgValue>
</operation>

<operation id="7" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="4" bw="0" op_0_bw="0" op_1_bw="64">
<![CDATA[
newFuncRoot:1 %specbramwithbyteenable_ln0 = specbramwithbyteenable void @_ssdm_op_SpecBRAMWithByteEnable, i64 %cacheMemory

]]></Node>
<StgValue><ssdm name="specbramwithbyteenable_ln0"/></StgValue>
</operation>

<operation id="8" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="5" bw="0" op_0_bw="0" op_1_bw="8" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
newFuncRoot:2 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i8 %newData, void @empty_1, i32 0, i32 0, void @empty_0, i32 4294967295, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="9" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="6" bw="6" op_0_bw="6" op_1_bw="6">
<![CDATA[
newFuncRoot:3 %or_ln11_read = read i6 @_ssdm_op_Read.ap_auto.i6, i6 %or_ln11

]]></Node>
<StgValue><ssdm name="or_ln11_read"/></StgValue>
</operation>

<operation id="10" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="7" bw="0" op_0_bw="3" op_1_bw="3">
<![CDATA[
newFuncRoot:4 %store_ln0 = store i3 0, i3 %i

]]></Node>
<StgValue><ssdm name="store_ln0"/></StgValue>
</operation>

<operation id="11" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="8" bw="0" op_0_bw="0">
<![CDATA[
newFuncRoot:5 %br_ln0 = br void %for.inc

]]></Node>
<StgValue><ssdm name="br_ln0"/></StgValue>
</operation>

<operation id="12" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="10" bw="3" op_0_bw="3" op_1_bw="0">
<![CDATA[
for.inc:0 %i_1 = load i3 %i

]]></Node>
<StgValue><ssdm name="i_1"/></StgValue>
</operation>

<operation id="13" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="11" bw="0" op_0_bw="0" op_1_bw="32" op_2_bw="32" op_3_bw="32" op_4_bw="32" op_5_bw="0">
<![CDATA[
for.inc:1 %specpipeline_ln0 = specpipeline void @_ssdm_op_SpecPipeline, i32 4294967295, i32 0, i32 1, i32 0, void @p_str

]]></Node>
<StgValue><ssdm name="specpipeline_ln0"/></StgValue>
</operation>

<operation id="14" st_id="1" stage="1" lat="1">
<core>Cmp</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="12" bw="1" op_0_bw="3" op_1_bw="3">
<![CDATA[
for.inc:2 %icmp_ln11 = icmp_eq  i3 %i_1, i3 4

]]></Node>
<StgValue><ssdm name="icmp_ln11"/></StgValue>
</operation>

<operation id="15" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="13" bw="32" op_0_bw="32" op_1_bw="64" op_2_bw="64" op_3_bw="64">
<![CDATA[
for.inc:3 %empty = speclooptripcount i32 @_ssdm_op_SpecLoopTripCount, i64 4, i64 4, i64 4

]]></Node>
<StgValue><ssdm name="empty"/></StgValue>
</operation>

<operation id="16" st_id="1" stage="1" lat="1">
<core>Adder</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="14" bw="3" op_0_bw="3" op_1_bw="3">
<![CDATA[
for.inc:4 %add_ln11_1 = add i3 %i_1, i3 1

]]></Node>
<StgValue><ssdm name="add_ln11_1"/></StgValue>
</operation>

<operation id="17" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="15" bw="0" op_0_bw="1" op_1_bw="0" op_2_bw="0">
<![CDATA[
for.inc:5 %br_ln11 = br i1 %icmp_ln11, void %for.inc.split, void %if.end.loopexit.exitStub

]]></Node>
<StgValue><ssdm name="br_ln11"/></StgValue>
</operation>

<operation id="18" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="icmp_ln11" val="0"/>
</and_exp></or_exp>
</condition>

<Node id="17" bw="64" op_0_bw="3">
<![CDATA[
for.inc.split:0 %i_cast5 = zext i3 %i_1

]]></Node>
<StgValue><ssdm name="i_cast5"/></StgValue>
</operation>

<operation id="19" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="icmp_ln11" val="0"/>
</and_exp></or_exp>
</condition>

<Node id="20" bw="2" op_0_bw="8" op_1_bw="64" op_2_bw="64">
<![CDATA[
for.inc.split:3 %newData_addr = getelementptr i8 %newData, i64 0, i64 %i_cast5

]]></Node>
<StgValue><ssdm name="newData_addr"/></StgValue>
</operation>

<operation id="20" st_id="1" stage="2" lat="2">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="icmp_ln11" val="0"/>
</and_exp></or_exp>
</condition>

<Node id="21" bw="8" op_0_bw="2">
<![CDATA[
for.inc.split:4 %newData_load = load i2 %newData_addr

]]></Node>
<StgValue><ssdm name="newData_load"/></StgValue>
</operation>

<operation id="21" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="icmp_ln11" val="0"/>
</and_exp></or_exp>
</condition>

<Node id="35" bw="0" op_0_bw="3" op_1_bw="3" op_2_bw="0" op_3_bw="0">
<![CDATA[
for.inc.split:18 %store_ln11 = store i3 %add_ln11_1, i3 %i

]]></Node>
<StgValue><ssdm name="store_ln11"/></StgValue>
</operation>
</state>

<state id="2" st_id="3">

<operation id="22" st_id="2" stage="1" lat="2">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="21" bw="8" op_0_bw="2">
<![CDATA[
for.inc.split:4 %newData_load = load i2 %newData_addr

]]></Node>
<StgValue><ssdm name="newData_load"/></StgValue>
</operation>

<operation id="39" st_id="2" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="icmp_ln11" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="38" bw="0">
<![CDATA[
if.end.loopexit.exitStub:0 %ret_ln0 = ret

]]></Node>
<StgValue><ssdm name="ret_ln0"/></StgValue>
</operation>
</state>

<state id="3" st_id="4">

<operation id="23" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="18" bw="6" op_0_bw="3">
<![CDATA[
for.inc.split:1 %i_cast = zext i3 %i_1

]]></Node>
<StgValue><ssdm name="i_cast"/></StgValue>
</operation>

<operation id="24" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="19" bw="0" op_0_bw="0" op_1_bw="0">
<![CDATA[
for.inc.split:2 %specloopname_ln11 = specloopname void @_ssdm_op_SpecLoopName, void @empty_3

]]></Node>
<StgValue><ssdm name="specloopname_ln11"/></StgValue>
</operation>

<operation id="25" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="22" bw="2" op_0_bw="3">
<![CDATA[
for.inc.split:5 %trunc_ln11 = trunc i3 %i_1

]]></Node>
<StgValue><ssdm name="trunc_ln11"/></StgValue>
</operation>

<operation id="26" st_id="3" stage="1" lat="1">
<core>Adder</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="23" bw="6" op_0_bw="6" op_1_bw="6">
<![CDATA[
for.inc.split:6 %add_ln11 = add i6 %i_cast, i6 %or_ln11_read

]]></Node>
<StgValue><ssdm name="add_ln11"/></StgValue>
</operation>

<operation id="27" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="24" bw="64" op_0_bw="8">
<![CDATA[
for.inc.split:7 %zext_ln11 = zext i8 %newData_load

]]></Node>
<StgValue><ssdm name="zext_ln11"/></StgValue>
</operation>

<operation id="28" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="25" bw="3" op_0_bw="3" op_1_bw="1" op_2_bw="2">
<![CDATA[
for.inc.split:8 %zext_ln11_1_cast = bitconcatenate i3 @_ssdm_op_BitConcatenate.i3.i1.i2, i1 1, i2 %trunc_ln11

]]></Node>
<StgValue><ssdm name="zext_ln11_1_cast"/></StgValue>
</operation>

<operation id="29" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="26" bw="8" op_0_bw="3">
<![CDATA[
for.inc.split:9 %zext_ln11_1 = zext i3 %zext_ln11_1_cast

]]></Node>
<StgValue><ssdm name="zext_ln11_1"/></StgValue>
</operation>

<operation id="30" st_id="3" stage="1" lat="1">
<core>Shifter</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="27" bw="8" op_0_bw="8" op_1_bw="8">
<![CDATA[
for.inc.split:10 %shl_ln11 = shl i8 1, i8 %zext_ln11_1

]]></Node>
<StgValue><ssdm name="shl_ln11"/></StgValue>
</operation>

<operation id="31" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="28" bw="6" op_0_bw="6" op_1_bw="1" op_2_bw="2" op_3_bw="3">
<![CDATA[
for.inc.split:11 %zext_ln11_2_cast = bitconcatenate i6 @_ssdm_op_BitConcatenate.i6.i1.i2.i3, i1 1, i2 %trunc_ln11, i3 0

]]></Node>
<StgValue><ssdm name="zext_ln11_2_cast"/></StgValue>
</operation>

<operation id="32" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="29" bw="64" op_0_bw="6">
<![CDATA[
for.inc.split:12 %zext_ln11_2 = zext i6 %zext_ln11_2_cast

]]></Node>
<StgValue><ssdm name="zext_ln11_2"/></StgValue>
</operation>

<operation id="33" st_id="3" stage="1" lat="1">
<core>Shifter</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="30" bw="64" op_0_bw="64" op_1_bw="64">
<![CDATA[
for.inc.split:13 %shl_ln11_1 = shl i64 %zext_ln11, i64 %zext_ln11_2

]]></Node>
<StgValue><ssdm name="shl_ln11_1"/></StgValue>
</operation>

<operation id="34" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="31" bw="3" op_0_bw="3" op_1_bw="6" op_2_bw="32" op_3_bw="32">
<![CDATA[
for.inc.split:14 %lshr_ln = partselect i3 @_ssdm_op_PartSelect.i3.i6.i32.i32, i6 %add_ln11, i32 3, i32 5

]]></Node>
<StgValue><ssdm name="lshr_ln"/></StgValue>
</operation>

<operation id="35" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="32" bw="64" op_0_bw="3">
<![CDATA[
for.inc.split:15 %zext_ln11_3 = zext i3 %lshr_ln

]]></Node>
<StgValue><ssdm name="zext_ln11_3"/></StgValue>
</operation>

<operation id="36" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="33" bw="3" op_0_bw="64" op_1_bw="64" op_2_bw="64">
<![CDATA[
for.inc.split:16 %cacheMemory_addr = getelementptr i64 %cacheMemory, i64 0, i64 %zext_ln11_3

]]></Node>
<StgValue><ssdm name="cacheMemory_addr"/></StgValue>
</operation>

<operation id="37" st_id="3" stage="1" lat="1">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="34" bw="0" op_0_bw="0" op_1_bw="3" op_2_bw="64" op_3_bw="8">
<![CDATA[
for.inc.split:17 %store_ln11 = store void @_ssdm_op_Write.bram.p0L_a8i8packedL, i3 %cacheMemory_addr, i64 %shl_ln11_1, i8 %shl_ln11

]]></Node>
<StgValue><ssdm name="store_ln11"/></StgValue>
</operation>

<operation id="38" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="36" bw="0" op_0_bw="0">
<![CDATA[
for.inc.split:19 %br_ln11 = br void %for.inc

]]></Node>
<StgValue><ssdm name="br_ln11"/></StgValue>
</operation>
</state>
</state_list>


<ports>
</ports>


<dataflows>
</dataflows>


</stg>
